#[cfg(feature = "ssr")]
pub mod server;

pub mod client;

use serde::{Deserialize, Serialize};

use crate::util::surrealdb::schemas::Participant;

#[derive(Serialize, Deserialize)]
pub enum ParticipantsAction {
    Add { participant: Participant },
    Replace { participant: Participant },
    Remove { id: String },
}

/*
pub fn apply_participants_patch(mut participants: Vec<Participant>, action: ParticipantsAction) {
    match action {
        ParticipantsAction::Add { participant } => {
            participants.push(participant);
        }
        ParticipantsAction::Remove { id } => {
            participants.retain(|participant| participant.id != id);
        }
        ParticipantsAction::Replace { participant } => {
            if let Some(index) = participants
                .iter()
                .position(|item| item.id == participant.id)
            {
                let _ = std::mem::replace(&mut participants[index], participant);
            }
        }
    }
}
*/
